C  ROSENBROCK.
C  X* = (1,1)
C  F* = 0
      FUNCTION FUNMIN ( X, N )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N)
C
      X1 = X(1)
      X2 = X(2)
C
      FUNMIN = 100.*(X2-X1**2)**2 + (1.-X1)**2
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE GRANAL ( N, X, VAL, GRAD )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N), GRAD(N)
C
      X1 = X(1)
      X2 = X(2)
C
      A = X2-X1*X1
      GRAD(1) = -400.*A*X1 - 2.*(1.-X1)
      GRAD(2) = 200.*A
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE SUBSUM ( M, N, X, F )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N), F(M)
C
      X1 = X(1)
      X2 = X(2)
C
      F(1) = 10.*(X2-X1**2)
      F(2) = 1.-X1
      END
